version = '3.00.20';
var host = window.external.Application;
defdoc();
var master = null;
var lang = [];
var hint = [];
var btns = [];
var domove = false;
var tg60 = 1.73205080757;
if(sRead('lang')===undefined){
	sWrite('lang','ru');
	sWrite('cat_settings','true');
}
var cLang = sRead('lang');
//cLang="ru";
var clrs = [];
clrs['yellow']=['FFE','FFF'];
clrs['yellow dark']=['FFD','FFE'];
clrs['red']=['FEF','FFF'];
clrs['blue']=['EFF','FFF'];
clrs['white']=['EEE','FFF'];
clrs['gray1']=['DDD','EEE'];
clrs['gray2']=['BBB','CCC'];
clrs['gray3']=[999,'AAA'];
clrs['gray4']=[777,999];
clrs['gray5']=[555,777];
clrs['dark']=[444,555];

if(sRead('bgcolor')===undefined) sWrite('bgcolor','white');
var cColor = (!clrs[sRead('bgcolor')]) ? clrs['white'] : clrs[sRead('bgcolor')];
//var cColor = clrs['white'];
var head  = document.getElementsByTagName('head')[0];

var link  = document.createElement('script');
link.type = 'text/javascript';
link.src = 'langs/ru.js';
head.appendChild(link);

var link  = document.createElement('script');
link.type = 'text/javascript';
link.src = 'langs/' + cLang + '.js';
head.appendChild(link);

in_main = document.title.substring(0,13)=="Woodman Panel";

function do_langs_list(){
	var langs = [];
	langs['ru']='Русский';
	langs['en']='English';
	langs['de']='Deutch';
	langs['es']='Español';
	langs['pl']='Polski';
	langs['ua']='Український';
	langs['kz']='Казахский';
	langs['uz']='Узбекский';
	langs['bg']='Bulgarian';
	langs['cn']='中文';

	for(var key in langs){
		sel = (cLang == key) ? ' SELECTED' : '';
		document.write('<option value="'+key+'"'+sel+'>'+langs[key]+'</option>');
	}
}

function do_setcolor_list(){
	for(var key in clrs){
		sel = (cColor[0] == clrs[key][0]) ? ' SELECTED' : '';
		document.write('<option value="'+key+'"'+sel+' style="background:#'+clrs[key][0]+'">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>');
	}
}

function do_contur_btns(){
	cols=sRead('val_set_conturs');
	if(!cols) cols = 7;
	if (cols<3) cols=3;
	if (cols>10)cols=10;
	colwi=(91/cols)+"%";
	for(i=1;i<=cols;i++) document.write('<img src="img/rou.png" style="width:'+colwi+'" onclick="make_round('+i+')" value="rou" id="cont_round_'+i+'" /> ');
	for(i=1;i<=cols;i++) document.write('<img src="img/cont_out.png" style="width:'+colwi+'" onclick="make_contur(1,'+i+')" value="out" id="cont_out_'+i+'" /> ');
	for(i=1;i<=cols;i++) document.write('<input type="text" id="val_cont_'+i+'" style="width:'+colwi+'" value="'+(getRandom(10,0.1,1))+'" onChange="do_save(this)" /> ');
	for(i=1;i<=cols;i++) document.write('<img src="img/cont_in.png"  style="width:'+colwi+'" onclick="make_contur(0,'+i+')" value="in" id="cont_in_'+i+'" /> ');
}

function do_fefco_list(){
	fldr = ReadFolder('fefco');
	curf = sRead('fefco_list');
	for(var key in fldr){
		file = fldr[key].substring(0,4);
		sel = (file == curf) ? ' SELECTED' : '';
		document.write('<option value="'+file+'"'+sel+'>'+file+'</option>');
	}
}

function do_color_list(){
	var colors = ["000","666","999","FFF","F00","F60","FF0","0F0","0FF","00F","90C","F0F"];
	mc = colors.length;
	var cur_color = sRead('gapcolor');
	for(var i=0;i<colors.length;i++){
		color = colors[i];
		sel = (color == cur_color) ? ' SELECTED' : '';
		document.write('<option value="'+color+'"'+sel+' style="background:#'+color+'">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>');
	}
}

function OnLoad(){
	for(var key in hint){
		if(key.substring(0,5)=="cont_"){
			for(var i=1;i<20;i++){
				var but = document.getElementById(key+i);
				if(but) but.title=hint[key];
			}
		}else{
			var but = document.getElementById(key);
			if(but) but.title=hint[key];
		}
	}
	var elems = document.getElementsByTagName('label');
	for (var i = 0; i < elems.length; i++){
		var el = elems[i];
		if(hint[el.htmlFor]) el.title=hint[el.htmlFor];
	}
	
	for(var key in btns){
		if(key.substring(0,5)=="cont_"){
			for(i=1;i<20;i++){
				var but = document.getElementById(key+i);
				if(but) but.value=btns[key];
			}
		}else{
			var but = document.getElementById(key);
			if(but){
				if(btns[key].substring(0,4)=="src:"){
					but.style.backgroundImage= "url('"+btns[key].substring(4)+"')";
					but.value="";
				}else{
					but.value=btns[key];
				}
			}
		}
	}
		
	if(sRead('cats')){
		cats = sRead('cats').split("/");
		if (cats.length>3){
			for (var i = cats.length-1; i >= 0 ; i--){
				prv = cats[i];
				nxt = cats[i+1];
				ids = prv.substring(6);
				el_nxt1 = document.getElementById(prv);
				el_nxt2 = document.getElementById(ids);
				el_prv = document.getElementById(nxt);
				document.body.insertBefore(el_nxt1,el_prv);		
				document.body.insertBefore(el_nxt2,el_prv);		
			}	
		}
	}
	
	if(sRead('ch_set_titles')=="false" && in_main){
		all_tabs.style.width="100%";
		var elems = document.getElementsByTagName('p');
		for (var i = 0; i < elems.length; i++){
			var el = elems[i];
			if(el.id.substring(0,10)=="title_cat_"){
				var img  = document.createElement('span');
				ids = el.id.substring(6);
				img.innerHTML = '<img src="img/'+el.id+'.png" id="img_'+el.id+'" class="float_but_title" onClick="ShowCat(\''+ids+'\')" lang="'+hint[el.id]+'" title="'+lang[el.id]+'"/>';
				all_tabs.appendChild(img);
			}
		}
	}
	
	document.body.style.background = "#" + cColor[0];
	if (cColor[0]>0 && cColor[0]<888){document.body.style.color="EEE";}

	var elems = document.getElementsByTagName('div');
	var cnt = 0;
	for (var i = 0; i < elems.length; i++){
		var el = elems[i];
		if(el.id.substring(0,4)=="cat_"){
			colo = (cnt % 2 == 0) ? cColor[0] : cColor[1];
			var tit = document.getElementById('title_' + el.id);
			tit.style.background = "#" + colo;
			el.style.background =  "#" + colo;
			cnt++;
		}
	}
	do_read();

    
	//window.external.Application.InitializeVBA();
//	RegisterEvent();      // tells draw to notify us when the selection changes.
//	OnSelectionChange();  // initialize the dialog
	tm = sRead('stat_time');
	var now = new Date();
	if (tm==undefined) tm = [77,77]; else tm = tm.split(":");
	if( Math.abs(now.getHours()-tm[1])>4	 || now.getDate() != tm[0]){
		sStatSend(version);
		sWrite('stat_time',now.getDate() + ":" + now.getHours());
	}
  }
function show_title(tit){
	if(sRead('ch_set_titles')!="false" || !in_main){
		document.write(lang[tit]);
		if(sRead('ch_set_titles_move')=="true"){
			document.write('<span style="position:absolute;right:4;"><input type="button" style="width:20px" onclick="do_move(\''+tit+'\',\'up\')" value="&and;" /><input type="button" style="width:20px" onclick="do_move(\''+tit+'\',\'dn\')" value="&or;" /></span>');
		}
	}
}
function showhide(id){
	cat = document.getElementById(id);
	cat.style.display = (cat.style.display == "block") ? "none" : "block";
}
function ShowCat(cat_id, show){
	if(show === undefined) show = "def";
	if (!domove){
		if (Shift()==4){
			var elems = document.getElementsByTagName('p');
			for (var i = 0; i < elems.length; i++){
				var el = elems[i];
				if (el){
					if(el.id.substring(0,10)=="title_cat_"){
						ids = el.id.substring(6);
						var cat = document.getElementById(ids);
						if(cat){
							cat.style.display = "none";
							if(sRead('ch_set_titles')=="false" && in_main){
								img = document.getElementById("img_title_" + ids);
								img.style.filter  = 'alpha(opacity=30)';
							}
							do_save(cat);
						}
					}
				}
			}			
		}
		titcat = document.getElementById("title_" + cat_id);
		cat = document.getElementById(cat_id);
		img = document.getElementById("img_title_" + cat_id);
		if(show=="def")	show = (cat.style.display == "block") ? false : true;
		if (!show){
			cat.style.display = "none";
			if(sRead('ch_set_titles')=="false" && in_main){
				img.style.filter  = 'alpha(opacity=30)';
				titcat.style.padding="0";
			}else{
				titcat.style.paddingBottom="2px";
			}
				//border-top: solid 1px;
			//titcat.style.borderBottom = "solid 1px";
			cat.style.paddingBottom="0";
		}else{
			cat.style.display = "block";
			if(sRead('ch_set_titles')=="false" && in_main){
				img.style.filter  = 'alpha(opacity=100)';
				titcat.style.padding="0";
				cat.style.paddingBottom="3px";
				cat.style.borderBottom="solid 1px black";
			}else{
				titcat.style.padding="2px";
				cat.style.paddingBottom="6px";
			}
			
			
		}
		do_save(cat);
	}
	domove = false;
}
/*
function RegisterEvent(){
    // tell coreldraw to call OnSelectionChange when the selection changes
	window.external.RegisterEventListener( "SelectionChange", "OnSelectionChange()" );
}
function UnregisterEvent(){
    // if you want to stop listening for the selection change event, call this function
    window.external.UnregisterEventListener( "SelectionChange" );
}*/

function scan_colors(){
	do_events("button_scan_colors");
	var fcolors = [];
	var ocolors = [];
	col_btns = document.getElementById("scan_colors_buttons");
	col_sel = document.getElementById("button_select_colors");
	shft = Shift();
	var OS = get_OS(false);
	col_btns.innerHTML = '';
	for(i=1;i<OS.Shapes.Count+1;i++){
		s = OS.Shapes(i);
		if(isSimpleShape(s)){
			if(s.Fill.Type==0){
				if (!fcolors[0]){fcolors[0]=0;}
				fcolors[0]++;
			}else{
				hex = s.Fill.UniformColor.HexValue;
				if (!fcolors[hex]){fcolors[hex]=0;}
				fcolors[hex]++;
			}
			if(s.Outline.Type==0){
				if (!ocolors[0]){ocolors[0]=0;}
				ocolors[0]++;
			}else{
				hex = s.Outline.Color.HexValue;
				if (!ocolors[hex]){ocolors[hex]=0;}
				ocolors[hex]++;
			}
		}
	}
	cnt_all=0;
	i=0;
	for(var key in ocolors){
		ids = "ocolor_" + i;
		styleo = (key!=0) ? "border:solid 3px " + key : "";
		var link  = document.createElement('span');
		link.innerHTML = '<input type="button" id="'+ids+'" class="color_btn" style="'+styleo+'" value="'+ocolors[key]+'" title="'+ocolors[key]+'" onClick="select_color('+ids+')" name="outl" src="'+key+'" />';
		col_btns.appendChild(link);
		col_sel.disabled=false;
		cnt_all++;
		i++;
	}
	for(var key in fcolors){
		cnt_all++;
	}

	btn_cnt = Math.floor(col_btns.offsetWidth/40);
	
	if(cnt_all>btn_cnt) {col_btns.appendChild(document.createElement('br'));}
	i=0;
	for(var key in fcolors){
		ids = "fcolor_" + i;
		stylef = (key!=0) ? "background-color:" + key : "";
		var link  = document.createElement('span');
		link.innerHTML = '<input type="button" id="'+ids+'" class="color_btn" style="'+stylef+'" value="'+fcolors[key]+'" title="'+fcolors[key]+'" onClick="select_color('+ids+')" name="fill" src="'+key+'" />';
		col_btns.appendChild(link);
		col_sel.disabled=false;
		i++;
	}
	//col_btns.appendChild(document.createElement('br'));
	
}	
function select_color(ids){
	do_events(ids.id);
	if(ids.name=="outl"){
		ids.value = "";
		ids.style.backgroundImage= "url('img/check.png')";
		ids.name="outl_sel";
	}else if(ids.name=="outl_sel"){
		ids.value = ids.title;
		ids.style.backgroundImage= "";
		ids.name="outl";
	}else if(ids.name=="fill"){
		ids.value = "";
		ids.style.backgroundImage= "url('img/check.png')";
		ids.name="fill_sel";
	}else if(ids.name=="fill_sel"){
		ids.value = ids.title;
		ids.style.backgroundImage= "";
		ids.name="fill";
	}
}
	
/* Corel functions*/	
function select_colors(){
	var srr;
	var arro = [];
	var arrf = [];
	var elems = document.getElementsByTagName('*');
	cfnd=false;
	for (var i = 0; i < elems.length; i++){
		elem = elems[i];
		if(elem.name=="outl_sel") {arro[elem.src]=elem.src; cfnd=true;select_color(elem);}
		if(elem.name=="fill_sel") {arrf[elem.src]=elem.src; cfnd=true;select_color(elem);}
	}
	srr = get_OS(false);
	if (cfnd){
		host.ActiveDocument.ClearSelection();
		shft = Shift();		
		srr = (shft==2 || shft==3) ? do_each("select_no_colors",srr,false,[arro,arrf]) : do_each("select_colors",srr,false,[arro,arrf]);
	}
	return srr;
}

function make_contur(direct, src, OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS();
	shft = Shift();
	size = document.getElementById("val_cont_" + src);
	if((shft==7 && OS.Shapes.Count>1) || (ch_master_sample.checked && master)){
		lst = (shft==7) ? OS.FirstShape : master;
		siz = lastSize(lst);
		if(siz>0){do_each("make_contur",OS,undogroup,[direct,siz]).CreateSelection();}
	}else if(shft>1 && shft!=5 && shft<7){
		pdir = (direct==1) ? 1 : -1;
		if(shft==2) size.value = vall(size.value,false,4)+1*pdir;
		if(shft==4) size.value = vall(size.value,false,4)+0.1*pdir;
		if(shft==6) size.value = vall(size.value,false,4)+0.5*pdir;
	}else{
		do_each("make_contur",OS,undogroup,[direct,vall(size.value)]).CreateSelection();
	}
	do_save(size);
}

function make_round(src, OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS();
	size = document.getElementById("val_cont_" + src);

	if((shft==7 && OS.Shapes.Count>1) || (ch_master_sample.checked && master)){
		lst = (shft==7) ? OS.FirstShape : master;
		siz = lastSize(lst);
		if (shft==7) OS.Remove(1);
	}else{
		siz = vall(size.value);
	}
	
	if(siz>0) do_each("round",OS,undogroup,siz).CreateSelection();
	do_save(size);
}	

function make_rotate(ang, OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS();
	do_each("rotate",OS,undogroup,ang).CreateSelection();
	do_save(val_rotate);
}	

function make_raspred(type, OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS(false,false);
	if(defdoc()){
		var sr = host.ActiveSelectionRange;
		sr.RemoveAll();
		shft = Shift();
		do_save(val_raspred);
		do_begin("raspred_" + type,undogroup);
		lst = OS.FirstShape;
		fst = OS.LastShape;	
		rval = vall(val_raspred.value);
		cnt_os = OS.Shapes.Count;
		
		if(type!="shapes"){
			lst_len = lst.DisplayCurve.Length;
			OS.Remove(1);
			cnt_os = OS.Shapes.Count;
		}
		OS = OS.ReverseRange;
		if(type=="nodes"){
				cnt_nd=1;
				for (i=1;i<=lst.DisplayCurve.Nodes.Count;i++){
					nd = lst.DisplayCurve.Nodes(i);
					if (cnt_os==1){
						obj = OS.Shapes(1).Duplicate();
					}else if (cnt_os>=cnt_nd){
						obj = OS.Shapes(cnt_nd);
					}else{
						obj=false;
					}
					if (obj){
						only_line = false;
						if ((shft == 2 || shft == 3) && nd.PrevSegment && nd.NextSegment ){
							if (Math.abs(Math.abs(nd.PrevSegment.EndingControlPointAngle - nd.NextSegment.StartingControlPointAngle) - 180) < 1) only_line = true;
						}
						if ((shft != 2 && shft != 3) || only_line){
							obj.centerX = nd.PositionX;
							obj.centerY = nd.PositionY;
							if (ch_raspred_rotate.checked){
								if (nd.NextSegment){
									ang = nd.NextSegment.StartingControlPointAngle;
								}else{
									ang = nd.Segment.EndingControlPointAngle + 180;
								}
								obj.rotate (ang);
							}
							cnt_nd++;
							sr.Add(obj);
						}else{
							obj.Delete();
						}
					}
				}
		}else if(type=="dist" || type=="qty"){
			if (cnt_os==1){
				swi = fst.SizeWidth;
				if(type == "qty"){
					kol = rval;
					dist = (lst.DisplayCurve.Closed) ? lst_len / kol : lst_len / (kol - 1);
				}else{
					dist = (ch_raspred_center.checked) ? rval : rval+swi;
					kol = lst_len/dist + 1;
				}
			}else{
				kol = cnt_os;
				if(type=="qty") dist = lst_len / cnt_os;
			}
			var off = 0;
			var x = 0;
			var y = 0;
			for(var k=1;k<=kol;k++){
				var dlina_curvy = 0;
				for (var i=1;i<=lst.DisplayCurve.Segments.Count;i++){
					seg = lst.DisplayCurve.Segments(i);
					if(off >= dlina_curvy && off <= (dlina_curvy + seg.Length)){
						pts = seg.GetPointAt(off - dlina_curvy, 0);
						//alert(off - dlina_curvy + ":" + dlina_curvy);
						last_dist = 0;
						if(cnt_os > 1){
							obj = OS.Shapes(k);
							cur_dist = obj.SizeWidth/2;
							if(type=="dist") dist = (ch_raspred_center.checked) ? rval : rval+(cur_dist+last_dist);
							if (shft==2) dist = cur_dist+last_dist + (objn.leftx - obj.rightx)
							last_dist = cur_dist;
						}else{
							obj = fst.Duplicate();
						}
						obj.PositionX = pts.x;
						obj.PositionY = pts.y;
						sr.Add(obj)
						if (ch_raspred_rotate.checked) obj.rotate (seg.GetTangentAt(off - dlina_curvy, 0));
						break;
					}
					dlina_curvy = dlina_curvy + seg.length;
				}
				off = off + dist;
				//alert("off:" + off);
				if(off > lst.DisplayCurve.length && type != "dist") off = lst.DisplayCurve.length;
			}

			allwi = 0;
			for (i=1;i<=cnt_os;i++){
				allwi+=OS.SHapes(i).SizeWidth;
			}
		}else if(type=="shapes"){
			half = cnt_os/2;
			for (i=1;i<=half;i++){
				if(shft==1 || shft==3 || shft==5 || shft==7){
					sd = OS.Shapes(i);
					ss = OS.Shapes(i+half);
				}else{
					ss = OS.Shapes(i);
					sd = OS.Shapes(i+half);
				}
				sx = ss.PositionX;
				sy = ss.PositionY;
				
				if(ch_raspred_rotate.checked){
					ss.RotationAngle = sd.RotationAngle;
					//ang = ss.RotationAngle;
					//sd.RotationAngle = ang;
				}
				if (shft>3){
					if (ss.Type==6) sd.Name = ss.Text.Story.Text;
				}else{
					ss.Move (sd.PositionX - sx, sd.PositionY - sy);
					if(shft==2 || shft==3 || shft==6 || shft==7) sd.Move (sx - sd.PositionX, sy - sd.PositionY);
				}
			}
		}else if(type=="round"){
			var cir_ang = 360 / cnt_os;
			for (var i=1;i<=cnt_os;i++){
				obj = OS.Shapes(i);
				obj.SetRotationCenter(lst.RotationCenterX,lst.RotationCenterY);
				dup = host.ActiveLayer.CreateLineSegment(obj.centerX, obj.centerY, lst.centerX, lst.centerY);
				cur_ang = dup.Curve.Segments.First.EndingControlPointAngle;
				if (i == 1) start_ang = (shft == 2) ? 90 : cur_ang;
				mang = start_ang  - (cur_ang + cir_ang * (i - 1));
				if (ch_raspred_rotate.checked){
					obj.rotate(mang);
				}else{
					dup.SetRotationCenter(lst.RotationCenterX,lst.RotationCenterY);
					dup.rotate(mang);
					obj.centerX = dup.Curve.Nodes.First.PositionX;
					obj.centerY = dup.Curve.Nodes.First.PositionY;
				}
				dup.Delete();
				obj.SetRotationCenter(obj.centerX,obj.centerY);
			}
		}
		do_end(undogroup);
	}
	return sr;
}	
function make_freza(type, OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS();
	if (OS.Shapes.Count<10)	do_each("freza",OS,undogroup,type).CreateSelection();
	do_save(val_freza);
}	

function make_gap(type, OS, undogroup){
	if(defdoc()){
		if(undogroup === undefined) undogroup = true;	
		if(OS === undefined) OS = get_OS(false,false);
		shft = Shift();
		do_save(val_razryv);
		do_begin("make gap " + type,undogroup);
		host.ActiveWindow.Activate();
		if(type=="del"){
			OS.Shapes.FindShapes("krugi", 0, false, "@Name!='dsf'").Delete();
		}else if (shft!=0 && OS.Shapes.Count>0){
			osw = OS.SizeWidth;
			for (var i=1;i<=OS.Shapes.Count;i++){
				gs = OS.Shapes(i);
				sx = gs.centerX;
				if(shft == 1 || shft == 5){
					gs.centerX = sx + osw;
					do_razryv (sx, gs.centerY);
					gs.centerX = sx;
				}else{
					do_razryv(gs.centerX, gs.centerY, gs);
				}
				if(shft < 3) gs.Delete();
			}
		}else{
			for (var i=1;i<=333;i++){
				var se = getClick();
				if (se[0]==1) break;
				do_razryv(se[1],se[2]);
			}
		}
		//do_each("freza",OS,undogroup,type).CreateSelection();
		do_end(undogroup);
	}
}	

function do_razryv(xx, yy, sha){
	if(sha === undefined) sha = false;	
    var gap = vall(val_razryv.value);
	var rgb = hextorgb(gapcolor.value);
	var RR = rgb[0];
	var GG = rgb[1];
	var BB = rgb[2];
	sel = host.ActivePage.SelectShapesAtPoint(xx, yy, false).Shapes.All();
	if(sha) for (var i=1;i<=sel.Shapes.Count;i++) if(sel.Shapes(i) == sha) sel.Remove(i);

  
    harea = (sha) ? sha.SizeHeight * sha.SizeWidth / 3 : harea = 0.1;
    if(sel.Shapes.Count > 0){
        for (var i=1;i<=sel.Shapes.Count;i++){
			var s = sel.Shapes(i);
            seg = false;
            if(s.Shapes.Count == 0){
                s.ConvertToCurves();
                seg = s.Curve.FindSegmentAtPoint(xx, yy, 0, harea);
            }else{
				ssel = getInGroup(s.Shapes.All());
				for (var si=1;si<=ssel.Shapes.Count;si++){
					ss = ssel.Shapes(si);
                    ss.ConvertToCurves();
                    seg = ss.Curve.FindSegmentAtPoint(xx, yy, 0, harea);
                    if (seg){s = ss; break;}
				}
			}
            
            if (seg){
                off = getSegOffbyXY(seg, xx, yy);
				seg.BreakApartAt(off);

				ci = (sha) ? sha.Duplicate() : host.ActiveLayer.CreateEllipse2(xx, yy, gap);
				
				if(ch_razryv_circle.checked){
					cibig = host.ActiveLayer.CreateEllipse2(xx, yy, gap*2);
					cibig.name = "krugi";
					cibig.Outline.Color = host.CreateRGBColor(BB, GG, RR);
				}
				
				if(ch_razryv_nedorez.checked) s.Intersect(ci).Outline.Color = host.CreateRGBColor(RR,GG,BB);

				ci.Trim(s, false);
			}	
		}
	}
}

function SelectOfType(type){
	do_events("button_SelectOfType "+ type );
	shft = Shift();
	//host.ActiveDocument.ClearSelection();		
	switch (type){
		case "sel_close_open": sr = (shft==2 || shft==3) ? do_each("sel_open") : do_each("sel_close"); break;
		case "sel_fill_no": 
			if (shft==2 || shft==3)
				sr = do_each("sel_nofill");
			else if (shft==4 || shft==5)
				sr = do_each("sel_otherfill");
			else
				sr = do_each("sel_fill"); 
			break;
		case "powerclip": sr = (shft==2 || shft==3) ? do_each("sel_nopower") : do_each("sel_power"); break;
		case "sel_outl_no": sr = (shft==2 || shft==3) ? do_each("sel_nooutl") : do_each("sel_outl"); break;
		case "sel_images": sr = (shft==2 || shft==3) ? do_each("sel_noimages") : (shft==4) ? do_each("ssel_image_trans") : do_each("sel_images"); break;
		case "sel_effect_no": sr = (shft==2 || shft==3) ? do_each("sel_noeffect") : do_each("sel_effect"); break;
		case "sel_lock": sr = (shft==2 || shft==3) ? do_each("sel_unlock") : do_each("sel_lock"); break;
		case "text": sr = (shft==2 || shft==3) ? do_each("sel_notext") : do_each("sel_text"); break;
		case "curve": sr = (shft==2 || shft==3) ? do_each("sel_nocurve") : do_each("sel_curve"); break;
		case "rectangle": sr = (shft==2 || shft==3) ? do_each("sel_norectangle") : do_each("sel_rectangle"); break;
		case "ellipse": sr = (shft==2 || shft==3) ? do_each("sel_noellipse") : do_each("sel_ellipse"); break;
		case "polygon": sr = (shft==2 || shft==3) ? do_each("sel_nopolygon") : do_each("sel_polygon"); break;

		default:
			var OS = get_OS();
			var query = "@type='" + type + "'";
			if(shft==2 || shft==3){
				query = replaceAll(query,"=","!=");
				query = replaceAll(query,"or","and");
			}
			shft = Shift();
			warn(shft);
			var ingroups = (shft==1) ? true : false;
			sr = OS.Shapes.FindShapes("", 0, ingroups, query);
		break;
	}
	return sr;
}
function set_master(){
	shft = Shift();
	if (master && shft==2){
		master.CreateSelection();
		//zoom = host.ActiveWindow.ActiveView.Zoom;
		//host.ActiveWindow.ActiveView.ToFitShape(master);
		//host.ActiveWindow.ActiveView.OriginX = master.CenterX;
		//host.ActiveWindow.ActiveView.OriginY = master.CenterY;
		//host.ActiveWindow.ActiveView.Zoom = zoom;
	}else{
		master = host.ActiveShape;
	}
}

function change_pos(){
	if (defdoc()){
		if (host.ActiveSelectionRange.Shapes.Count==2){
			host.ActiveDocument.BeginCommandGroup("change obj");
			oss = host.ActiveSelectionRange.Shapes;
			//rp = getRef();
			sx = oss(1).PositionX;
			sy = oss(1).PositionY;
			oss(1).PositionX = oss(2).PositionX;
			oss(1).PositionY= oss(2).PositionY;
			oss(2).PositionX = sx;
			oss(2).PositionY = sy;
			host.ActiveDocument.EndCommandGroup();
		}
	}
}

function master_fill(type, OS, undogroup){
	if(type === undefined) type = getRadio('group_master_fill').value;
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS(false,false);
	if (defdoc()){
		var sr = host.ActiveSelectionRange;
		sr.RemoveAll();
		shft = Shift();
		do_save(val_fill_kraj);
		do_save(val_fill_gap);
		if(master || isLast(OS)){
			lst = (shft==7) ? OS.FirstShape : master;
			siz = lastSize(lst);
			if (shft==7) OS.Remove(1);
			
			do_begin("master fill " + type,undogroup,true);
			val_kraj = vall(val_fill_kraj.value);
			val_gap = vall(val_fill_kraj.value);
			cnt_os = OS.Shapes.Count;
			msx = lst.leftx;
			mex = lst.rightx;
			msy = lst.topy;
			mey = lst.bottomy;
			mw = lst.SizeWidth;
			mh = (lst.type == 4) ? mw : lst.SizeHeight;
			marea = lst.DisplayCurve.Area;
			
			dopusk = (shft == 1 || shft == 5) ? marea*0.07 : 0.1;

			if(ch_master_fill_bycenter.checked){
				xi = val_gap;
				yi = val_gap;
			}else{
				xi = val_gap + mw;
				yi = val_gap + mh;
			}
			
			if (shft>3 && shft<7) yi = yi/2*tg60;
			
			for(sind=1;sind<=OS.Shapes.Count;sind++){
				s = OS.Shapes(sind);
				lst.OrderFrontOf(s);
				var dr = false;
				if(val_kraj != 0){
					dr = (val_kraj > 0) ? 0 : 1;
					s.CreateContour(dr, Math.abs(val_kraj), 1, 1, host.CreateCMYKColor(100, 100, 100, 100), host.CreateCMYKColor(100, 100, 100, 100), host.CreateCMYKColor(100, 100, 100, 100), 0, 0, 1, 2);
					if(s.Effects.Count > 0) s = s.Effects(1).Separate()(1);
				}
				sx = s.leftx;
				ex = s.rightx;
				sy = s.topy;
				ey = s.bottomy;
				
				//alert(sx + ":" + ex + ":" + sy + ":" + ey + ":" + xi + ":" + yi);

				row = 0;
				for(yy=sy;yy>=ey;yy-=yi){
					row++;
					re = host.ActiveLayer.CreateRectangle(sx, yy, ex, yy - mh);
					isecr = s.Intersect(re);
					if(isecr){
						il = isecr.LeftX;
						ir = isecr.RightX;
						isecr.Delete();
					}else{
						il = ex;
						ir = sx;
					}
					re.Delete();
					sxx = (shft>3 && shft<7 && row % 2 == 0) ? sx-xi/2 : sx;
					//alert(shft + ":" + plot);
					for(xx=sxx;xx<=ex;xx+=xi){
						if(xx >= il && xx <= ir || (type == "all" || type == "out" )){
							m = lst.Duplicate(xx - msx, yy - msy);
							if(type != "all"){
								isec = s.Intersect(m);
								del = true;
								if(isec){
									if(type == "full" && isec.DisplayCurve.Area > (marea - dopusk) || type == "part") del = false;
									isec.Delete();
								}else if (type == "out"){
									del = false;
								}
								if(del) m.Delete();
							}
						}
					}
				}
				if(val_kraj != 0) s.Delete();
			}
			do_end(undogroup);
		}
	}
}

function autogroup(group,OS,undogroup,param){
	if(group != undefined && host.ActiveDocument!=null){
		do_events(group);
		if(OS === undefined) OS = get_OS();
		if(undogroup === undefined) undogroup = true;
		shft = Shift();
		do_begin(group,undogroup);
		var sr_all = host.ActiveSelectionRange;
		sr_all.RemoveAll();
		var sr = host.ActiveSelectionRange;
		sr.RemoveAll();
		
		var arr_all = [];
		var sgap =  vall(val_groupgap.value);
		do_save(val_groupgap);
		
		gcnt = OS.Shapes.Count;

		if (group=="grp_addto"){
            OS = OS.Shapes.FindShapes("", 7, false);
			for(i=1;i<=OS.Shapes.Count;i++){
				s = OS.Shapes(i);
                sr.RemoveAll();
                sr.AddRange(s.UngroupEx());
                sr.Add(host.ActivePage.SelectShapesFromRectangle(sr.LeftX - sgap, sr.BottomY - sgap, sr.RightX + sgap, sr.TopY + sgap, true));
                sr.Group();
				if (sr.Shapes.Count > 0 ) sr_all.AddRange (sr);
            }
		}else{
			for(i=1;i<=gcnt;i++){
				s = OS.Shapes(i);
				arr_all[i] = [];
				for(j=1;j<=gcnt;j++){
					arr_all[i][j] = 0;
					if(i!=j){
						ss = OS.Shapes(j);
						if (ss.LeftX < s.RightX + sgap && ss.RightX > s.LeftX - sgap && ss.BottomY < s.TopY + sgap && ss.TopY > s.BottomY - sgap){
							if(group == "grp_byform"){
								isec = s.Intersect(ss);
								if (isec){
									arr_all[i][j] = j;
									isec.Delete();
								}
							}else{
								arr_all[i][j] = j;
							}
						}
					}else{
						arr_all[i][j] = i;
					}
				}
			}
			
			for(i=1;i<=gcnt;i++){
				arr_all = collect_arr(arr_all, i, i);
			}	
			
			for(i=1;i<=gcnt;i++){
				sr.RemoveAll();
				inar =0;
				for(j=1;j<=gcnt;j++){
					if (arr_all[i][j]>0){
						sr.Add(OS.Shapes(j));
						inar++;
					}
				}

				if (inar > 1) {
					if (shft == 4 && group == "grp_weld"){
						sr.Combine();
					}else{
						if (group == "grp_byframe" || group == "grp_byform") {
							if (shft < 4)  sr_all.add(sr.Group());
						} else {
							sr.sort("@shape1.width*@shape1.height < @shape2.width*@shape2.height");

							fs = sr.FirstShape;
							ls = sr.LastShape;

							for(k=1;k<=sr.Shapes.Count;k++){
								s = sr.Shapes(k);
								if (s != ls && s != fs) {
									fs = s.Weld(fs, false, false);
								}
							}
							if (group == "grp_weld") {
								ls = fs.Weld(ls, false);
							} else {
								ls = fs.Trim(ls, false);
							}
							if (ls) sr_all.add(ls);
						}
					}
				} 
			}
		}

		do_end(undogroup);
		return sr_all;
	}else{
		return 	getEOS();
	}		
}
// system functions

function collect_arr(arr, ci, ki) {
    for (var k = 0; k < arr.length; k++) {
        if (arr[ki][k] > 0) {
            arr[ci][k] = k;
            if (ki !== ci) {
                arr[ki][k] = null;
            }
            if (ci !== k && ki !== k) {
                arr = collect_arr(arr, ci, k);
            }
        }
    }
    //if (ki !== ci) { arr[ki][ki] = null; }
    return arr;
}

function do_each(name,OS,undogroup,param){
	if(name != undefined && host.ActiveDocument!=null){
		do_events(name);
		if(OS === undefined) OS = get_OS();
		if(undogroup === undefined) undogroup = true;
		shft = Shift();
		doall = true;
		if (OS.Shapes.Count>50) if (!confirm(lang['text_more50'])) doall = false;
		var sr = host.ActiveSelectionRange;
		sr.RemoveAll();
		if(doall){		
			doeach=true;
			do_begin(name,undogroup);
			ch_lst = false;
			glst = OS.FirstShape;
			gfst = OS.LastShape;
			for (i=1;i<=OS.Shapes.Count;i++){
				if (OS.Shapes(i).Shapes.Count==0) {
					fst = OS.Shapes(i);
					if(!ch_lst) lst = OS.Shapes(i);
					ch_lst = true;
				}
			}
			mlst = undefined;
			if(master) mlst = master;
			if(isLast(OS)){
				mlst = OS.FirstShape;
				OS.Remove(1);
			}
			if (mlst){
				lst_siz = lastSize(mlst);
				lst_ang = max_ang(mlst);
				lst_per = lastSize(mlst,true);
			}
			isLastGl = isLast(OS,true);
			switch(name){
				case "make_contur":
					todel = (shft==5) ? !ch_cont_del.checked : ch_cont_del.checked; 
					if(param[2] === undefined) param[2] = ch_cont_sep.checked;
					if(param[3] === undefined) param[3] = todel;
					if(param[4] === undefined) param[4] = ch_cont_round.checked;
					if(param[5] === undefined) param[5] = ch_cont_reduce.checked;
					if(param[6] === undefined) param[6] = ch_cont_cut.checked;
					break;
				case "sel_toup":OS.OrderToFront(); doeach = false; break;
				case "sel_todown":OS.OrderToBack(); doeach = false; break;
				case "set_sizes":  do_save(val_sizes_wi); do_save(val_sizes_hi); break;
				case "perimetr_get_size":val_perimetr.value = fst.DisplayCurve.Length*wScale; do_save(val_perimetr); doeach = false; break;
				case "perimetr_set_size":do_save(val_perimetr); break;
				case "punkt_get_dash": val_punkt_dash.value = fst.DisplayCurve.Segments.Count; do_save(val_punkt_dash); doeach = false; break;
				case "fefco": ffile = ReadFile('fefco/'+fefco_list.value+'.ini'); do_save(val_fefco_th);do_save(val_fefco_hi); fth = vall(val_fefco_th.value); fhi = vall(val_fefco_hi.value); break;		
				case "master_select": masterArea = (mlst) ? maxSPArea(mlst) : 0; break;
				case "rotate": 
					var mang = param;
					if(param=="ang"){
						var se = getClick();
						if (se[0]==1) {doeach = false; break;}
						mang = FindSegXY(se[1],se[2], host.ActivePage.SelectShapesAtPoint(se[1],se[2], false)).StartingControlPointAngle;
						if (mang > 180) mang -= 180;
						if(se[3]==2) mang *= -1;
					}else if(param>0){
						if(isAlt(shft))	mang *= -1;
						if (shft==2) param = "center";
					}
				break;
				case "make_sizes": 
					OS.CreateSelection();
					if (ch_sizes_hor.checked){
						dr = (isCtrl(shft)) ? "up" : "dn";
						if (ch_sizes_betw.checked && shft<4) dr +="b";
						MakeSize(dr, shft);
					}
					if (ch_sizes_ver.checked){
						dr = (isCtrl(shft)) ? "ri" : "lf";
						if (ch_sizes_betw.checked && shft<4) dr +="b";
						MakeSize(dr, shft);
					}
					doeach = false;
				break;
				case "freza": 
					freza_R = vall(val_freza.value)/2; 
					freza_Rk = freza_R * 4 / 3; 
					inp=false;
					if((shft==4 || shft==5) && !ch_freza_corners.checked){
						inp = prompt(lang["freza_title"],freza_R * 4 * wScale);
					}
				break;
				case "make_punktir":
					punkt_dash = vall(val_punkt_dash.value);
					punkt_gap = vall(val_punkt_gap.value);
					do_save(val_punkt_dash);
					do_save(val_punkt_gap);
				break;
				case "mashtab_set_size": 
					len = (fst.DisplayCurve.Closed) ? max_size(fst) : fst.DisplayCurve.Length;
					inp = (isLastGl) ? lst_siz : prompt(lang["mashtab_title"],len * wScale);
					if (inp>0){
						coef = vall(inp) / len;
						OS.SizeWidth = OS.SizeWidth * coef;
						OS.SizeHeight = OS.SizeHeight * coef;
					}
					doeach = false; 
				break;
			}
			if(doeach){
				for(sind=1;sind<=OS.Shapes.Count;sind++){
					s = OS.Shapes(sind);
					if(s.Locked){
						switch(name){
							case "sel_lock": sr.add(s); break;
							case "sel_unlock": if(s.Locked) {s.Locked=false; sr.add(s); }break;
						}
					}else{
						switch(name){
							case "sel_rectangle":if(s.Type==1) sr.add(s); break;
							case "sel_norectangle":if(s.Type!=1) sr.add(s); break;
							case "sel_ellipse":if(s.Type==2) sr.add(s); break;
							case "sel_noellipse":if(s.Type!=2) sr.add(s); break;
							case "sel_curve":if(s.Type==3) sr.add(s); break;
							case "sel_nocurve":if(s.Type!=3) sr.add(s); break;
							case "sel_polygon":if(s.Type==4) sr.add(s); break;
							case "sel_nopolygon":if(s.Type!=4) sr.add(s); break;
							case "sel_images": if(s.Type==5) sr.add(s); break;
							case "sel_noimages": if(s.Type!=5) sr.add(s); break;
							case "sel_text":if(s.Type==6) sr.add(s); break;
							case "sel_notext":if(s.Type!=6) sr.add(s); break;
							case "sel_close":if(s.DisplayCurve!=null) if (s.DisplayCurve.Closed) sr.add(s); break;
							case "sel_open":if(s.DisplayCurve!=null) if (!s.DisplayCurve.Closed) sr.add(s); break;
							case "sel_fill":if(s.Type!=7 && s.Fill.Type==1) sr.add(s); break;
							case "sel_otherfill":if(s.Type!=7 && s.Fill.Type>1) sr.add(s); break;
							case "sel_nofill":if(s.Fill.Type==0) sr.add(s); break;
							case "sel_outl":if(s.Outline.Type>0) sr.add(s); break;
							case "sel_nooutl":if(s.Outline.Type==0) sr.add(s); break;
							case "sel_image_trans": if(s.Outline.Type>0) sr.add(s); break;
							case "sel_effect": if(s.Effects.Count > 0) sr.add(s); break;
							case "sel_noeffect": if(s.Effects.Count == 0) sr.add(s); break;
							case "sel_power": if(s.PowerClip) sr.add(s); break;
							case "sel_nopower": if(!s.PowerClip) sr.add(s); break;
							case "sel_delete": s.Delete(); break;
							case "rotate": sr.Add(dos_rotate(s,mang,param,ch_rotate_rel.checked)); break;
							case "make_punktir": sr.Add(dos_punktir(s,punkt_dash,punkt_gap,radio_punktir_size.checked,ch_punkt_trim.checked,ch_punkt_del.checked,ch_punkt_join.checked,ch_punkt_line.checked)); break;
							case "make_contur": if(s.Effects.Count==0) sr.Add(dos_contur(s,param[1],param[0],param[2],param[3],param[4],param[5],param[6])); break;
							case "perimetr_set_size":
								if (s.Shapes.Count==0){
									//siz = lst_per;
									
									if (isLastGl){
										siz  = lst_per;
									}else{
										siz  = vall(val_perimetr.value);
									}
									coef = siz/s.DisplayCurve.Length;
									s.SetSize (s.SizeWidth*coef, s.SizeHeight*coef);
									do_save(val_perimetr);
									sr.add(s);
								}
							break;
							case "all_split":
								if(s.Effects.Count>0){
									sr.AddRange (s.Effects(1).Separate);
								}else if(s.PowerClip){
									sr.AddRange(s.PowerClip.ExtractShapes());
								}else{
									sr.AddRange(s.BreakApartEx());
								}
							break;
							case "select_colors":
								if(isSimpleShape(s) && s.Type!=7){
									add = false;
									for(var key in param[0]){if ((s.Outline.Type>0 && s.Outline.Color.HexValue==key) || (s.Outline.Type==0 && key==0)){add = true;}}
									for(var key in param[1]){if ((s.Fill.Type>0 && s.Fill.UniformColor.HexValue==key) || (s.Fill.Type==0 && key==0)){add = true;}}
									if(add) sr.add(s);
								}
							break;
							case "select_no_colors":
								if(isSimpleShape(s)  && s.Type!=7){
									add = false;
									for(var key in param[0]){if ((s.Outline.Type>0 && (s.Outline.Color.HexValue!=key || key==0)) || (s.Outline.Type==0 && key!=0)){add = true;}}
									for(var key in param[1]){if ((s.Fill.Type>0 && (s.Fill.UniformColor.HexValue!=key || key==0)) || (s.Fill.Type==0 && key!=0)){add = true;}}
									if(add) sr.add(s);
								}
							break;
							case "round":
								var arr_sel = [];
								bynode = false;
								if (s.Type==3){
									for(i=1;i<=s.Curve.Nodes.Count;i++){
										if (s.Curve.Nodes(i).Selected){
											arr_sel.push(i);
											bynode = true;
										}
									}
								}
								if (bynode){
									nr = s.Curve.Nodes.Range(1);
									nr.RemoveAll();
									for (var key in arr_sel){
										nr.AddRange(s.Curve.Nodes.Range(arr_sel[key]));
									}
									nr.Fillet(param); 
								}else{
									s.Fillet(param); 
								}
								sr.add(s);
							break;
							case "master_select":
								if(mlst){
									gap = 0.01;
									if (ch_master_sel_h.checked && !ch_master_sel_w.checked){
										scomp = s.SizeHeight;
										mcomp = mlst.SizeHeight;
									}else if (!ch_master_sel_h.checked && ch_master_sel_w.checked){
										scomp = s.SizeWidth;
										mcomp = mlst.SizeWidth;
									}else{
										scomp = s.SizeHeight * s.SizeWidth;
										mcomp = mlst.SizeHeight * mlst.SizeWidth;
										if (mlst.DisplayCurve && s.DisplayCurve){
											if(mlst.DisplayCurve.closed && s.DisplayCurve.closed){
												scomp = maxSPArea(s);
												mcomp = masterArea;
												gap = 0.1;
											}else if(!mlst.DisplayCurve.closed && !s.DisplayCurve.closed){
												scomp = s.DisplayCurve.length;
												mcomp = mlst.DisplayCurve.length;
											}
										}
									}
									if (shft==2 || shft==3){
										less = (radio_master_sel_l.checked) ? scomp<=mcomp : true;
										more = (radio_master_sel_m.checked) ? scomp>=mcomp : true;
									}else{
										less = (radio_master_sel_l.checked) ? scomp<mcomp : true;
										more = (radio_master_sel_m.checked) ? scomp>mcomp : true;
									}
									if(shft==4)
										equal = (radio_master_sel_e.checked) ? scomp==mcomp : true;
									else
										equal = (radio_master_sel_e.checked) ? Math.abs(scomp-mcomp)<gap : true;
									if(less && more && equal) sr.Add(s);
								}
							break;					
							case "set_sizes":
								if (ch_sizes_rotate.checked && s.Shapes.Count==0){
									ang = max_ang(s);
									s.Rotate(-ang);	
								}	
								
								swi = s.SizeWidth;
								shi = s.SizeHeight;
								wi = (isLastGl) ? mlst.SizeWidth : vall(val_sizes_wi.value);
								hi = (isLastGl) ? mlst.SizeHeight : vall(val_sizes_hi.value);
								
								if (isLastGl && ch_master_sel_h.checked && !ch_master_sel_w.checked){
									wi=0;
								}else if (isLastGl && !ch_master_sel_h.checked && ch_master_sel_w.checked){
									hi=0;
								}

								wi2 = wi;
								hi2 = hi;
								
								
								fstwi = val_sizes_wi.value.substring(0,1);
								fsthi = val_sizes_hi.value.substring(0,1);
								
								if (fstwi == "+" || fstwi == "-") wi2 = swi + wi;
								if (fsthi == "+" || fsthi == "-") hi2 = shi + hi;
								
								if (wi == 0) wi2 = swi;
								if (hi == 0) hi2 = shi;

								if (hi == 0 && ch_sizes_aspect.checked) hi2 = shi * wi2 / swi;
								if (wi == 0 && ch_sizes_aspect.checked) wi2 = swi * hi2 / shi;
								s.SetSize (vall(wi2), vall(hi2));

								if (ch_sizes_rotate.checked && s.Shapes.Count==0) s.Rotate(ang);	
								sr.Add(s);
							break;
							case "freza": 
								cnt_sp = s.DisplayCurve.SubPaths.Count;
								for(var i=1;i<=cnt_sp;i++){
									var arr_sel = [];
									sp = s.DisplayCurve.SubPaths(i);       
									for(var n=1;n<=sp.Nodes.Count;n++){
										nd = sp.Nodes(n);
										nX = nd.PositionX;
										nY = nd.PositionY;
										tang = nd.Segment.EndingControlPointAngle;
										nang = nd.Segment.Next().StartingControlPointAngle;
										if(sp.IsClockwise && sp.SizeHeight == s.SizeHeight && sp.SizeWidth == s.SizeWidth || !sp.IsClockwise && cnt_sp > 1 && (sp.SizeHeight < s.SizeHeight || sp.SizeWidth < s.SizeWidth)){
											ta = tang;
											na = nang;
										}else{
											ta = nang;
											na = tang;
										}
										
										if (param=="in"){
											ta = ta + na;
											na = ta - na;
											ta = ta - na;
										}
											
										ang = ta - na;
										if (ang < 0) ang = ang + 360;
										if (ang < 180 && nd.Segment.length > freza_Rk && nd.Segment.Next().length > freza_Rk){
											if(shft == 2 || shft==3){
												ci = host.ActiveLayer.CreateEllipse2(nX, nY, freza_R);
												sr.Add(ci);
											}else if(ch_freza_corners.checked){
												arr_sel.push(nd.AbsoluteIndex);
											}else{
												lin = host.ActiveLayer.CreateLineSegment(nX, nY, nX + freza_R, nY);
												lin.SetRotationCenter(nX, nY);
												if(ta < na) ta = ta + 360;
												if(inp){
													if (Math.abs(nd.Segment.Length-vall(inp))<0.5)
														ang = tang;
													else if (Math.abs(nd.Segment.Next().Length-vall(inp))<0.5)
														ang = nang;
												}else{
													ang = (ta + na) / 2;
												}
												lin.RotationAngle = ang;
												ci = host.ActiveLayer.CreateEllipse2(lin.Curve.Nodes.Last.PositionX, lin.Curve.Nodes.Last.PositionY, freza_R);
												sr.Add(ci);
												lin.Delete();
											}

										}
									}
									nr = sp.Nodes.Range(1);
									nr.RemoveAll();
									for (var key in arr_sel){
										nr.AddRange(s.Curve.Nodes.Range(arr_sel[key]));
									}
									nr.Fillet(freza_R); 
									
								}
							break;
							case "fefco":
								cx = s.CenterX;
								cy = s.CenterY;
								fwi = s.SizeWidth;
								fle = s.SizeHeight;
								mode="";
								lx=cx;
								ly=cy;
								for (var key in ffile){
									//line = ffile[key].split("=");
									line = ffile[key].split("=");
									lncnt = line.length;
									if(lncnt==1){
										mode = line[0];
									}else{
										for (var kl in line){
											var ln = line[kl].split(":");
											lcnt = ln.length;
											sum = 0;
											lm = false;
											rel = true;
											ss="";
											for (k=0;k<lcnt;k+=2){
												var t = ln[k];
												var v = ln[k+1];
												if(t.substring(0,2)=="LM"){lm="OK"; t = t.substring(2);}
												switch (t){
													case "W": t = fwi; break;
													case "L": t = fle; break;
													case "H": t = fhi; break;
													case "T": t = fth; break;
													case "CX": t = cx; rel = false; break;
													case "CY": t = cy; rel = false; break;
													case "LX": t = lx; rel = false; break;
													case "LY": t = ly; rel = false; break;
												}
												if (t=="SV" || t=="SH") ss = t+":"+v; else if (lm=="OK") lm = t*v; else sum += t*v;
											}
											if(lm){
												relsum = 0;
												
												if(!rel) relsum = (kl % 2 == 0) ? lx : ly;
												sum -= relsum;
												dir = (sum<0) ? -1 : 1;
												alert(relsum + ":" + sum + ":" + lm)
												if (Math.abs(sum)>lm) sum = lm*dir;
												sum += relsum;
											}
											if (ss.length>0) sum = ss +":"+ sum;
											line[kl] = sum;
											if (kl!=2 || lncnt!=3){ if (kl % 2 == 0) lx = sum; else ly = sum;}
										}
									}
									switch (mode){
										case "out":
											if (lncnt==4){
												lout = host.ActiveLayer.CreateLineSegment(line[0],line[1],line[2],line[3]);
											}else if (lncnt>1){
												if(line.length>2){
													if (line[2]>0){
														lout.Curve.SubPaths.Last.AppendLineSegment(line[0],line[1]);
														lout.Curve.Nodes.Last.Previous().Fillet(line[2]);
													}else{
														qty = line[2].split(":");
														siz = qty[2]/(3*qty[1]);
														dir = (siz<0) ? -1 : 1;
														if(qty[0]=="SH"){
															sx = line[0]-qty[2];
															lout.Curve.SubPaths.Last.AppendLineSegment(sx+siz,line[1]);
															lout.Curve.SubPaths.Last.AppendLineSegment(sx+siz+dir*fth*0.25,line[1]+dir*fth*1.5);
															if(fwi>111){
																lout.Curve.SubPaths.Last.AppendLineSegment(sx+2*siz-dir*fth*0.25,line[1]+dir*fth*1.5);
																lout.Curve.SubPaths.Last.AppendLineSegment(sx+siz*2,line[1]);
															}else{
																line[1]+=+dir*fth*1.5;
															}
															if(qty[1]==2){
															}
															
														}else if(qty[0]=="SV"){
															
														}
														lout.Curve.SubPaths.Last.AppendLineSegment(line[0],line[1]);
													}
												}else{
													lout.Curve.SubPaths.Last.AppendLineSegment(line[0],line[1]);
												}
											}
										break;
									}
								}
							break;
						}
					}
					
					if (s!=mlst && mlst){
						switch (name){
							case "master_replace":
								dup = mlst.Duplicate();
								sr.Add(dup);
								dup.Move (s.CenterX-mlst.CenterX, s.CenterY-mlst.CenterY)
								dup.OrderFrontOf(s);	
								
								if(ch_master_byends.checked && s.Shapes.Count==0){
									for(var k=1;k<=s.DisplayCurve.Nodes.Count;k++){
										nd = s.DisplayCurve.Nodes(k);
										if(nd.IsEnding){
											dup.PositionX = nd.PositionX;
											dup.PositionY = nd.PositionY;
											if (ch_master_rotate.checked){
												dup.RotationCenterX = nd.PositionX
												dup.RotationCenterY = nd.PositionY
												dup.RotationAngle = (nd.NextSegment) ? nd.NextSegment.EndingControlPointAngle : nd.PrevSegment.StartingControlPointAngle;
											}
											dup = mlst.Duplicate();
										}
									}
									dup.Delete();
								}else{
									if (ch_master_rotate.checked) dup.RotationAngle = max_ang(s);
									if (ch_master_size.checked) {
										koef = 0;
										if (ch_master_sel_w.checked && !ch_master_sel_h.checked){
											koef = (s.DisplayCurve.Closed) ? s.SizeHeight/dup.SizeHeight : s.DisplayCurve.length/dup.SizeHeight;
										}else if (ch_master_sel_h.checked && !ch_master_sel_w.checked){
											koef = (s.DisplayCurve.Closed) ? s.SizeWidth/dup.SizeWidth : s.DisplayCurve.length/dup.SizeWidth;
										}
										warn (koef);
									
										if(koef>0){
											dup.SizeWidth = dup.SizeWidth*koef;
											dup.SizeHeight = dup.SizeHeight*koef;
										}else{
											dup.SizeWidth = s.SizeWidth;
											dup.SizeHeight = s.SizeHeight;
										}
									}
								}
								if (ch_master_del.checked) s.Delete();
							break;
						}
					}
				}
				host.ActiveDocument.ClearSelection();
			}else{
				//sr.AddRange(OS);
			}
			do_end(undogroup);
		}
		return sr;
	}else{
		return 	getEOS();
	}
}

function dos_contur(s,size,dir,split,todel,round,reduce,cut){
	if (dir=="in") dir = 0;
	if (dir=="out") dir = 1;
	if(split === undefined) split = true;
	if(todel === undefined) todel = true;
	if(round === undefined) round = true;
	if(reduce === undefined) reduce = false;
	if(cut === undefined) cut = false;
	if(round){
		s.CreateContour(dir, size, 1, 0, s.Outline.Color, s.Fill.UniformColor, s.Fill.UniformColor, 0, 0, 1, 2);
	}else{
		s.CreateContour(dir, size, 1, 0, s.Outline.Color, s.Fill.UniformColor, s.Fill.UniformColor, 0, 0, 2, 4, 15);
	}
	if(s.Effects.Count > 0 && split){
		spr = s.Effects(1).Separate()(1);
		if(reduce && spr.Type==3) spr.Curve.AutoReduceNodes(2);
		if (cut) 
			if(dir==1)
				spr = s.Trim(spr,true);
			else
				spr = spr.Trim(s,false,true);
		if(s.PowerClip==null){
			if (todel) s.Delete();
			s = spr;
		}else{
			s.Curve.CopyAssign(spr.Curve);
			spr.Delete();
		}				
	}
	return s;
}

function dos_rotate(s, ang, param, rotate_rel){
	if(param === undefined) param = 0;
	if(rotate_rel === undefined) rotate_rel = true;	
	if (param=="long"){
		s.Rotate(-max_ang(s,false));
	}else if (param=="ang"){
		if(shft>0) s.Rotate(ang); else s.Rotate(-ang);
	}else if (param=="center"){
		s.SetRotationCenter(s.centerX,s.centerY); 
	}else{
		if(rotate_rel) s.Rotate(ang); else  s.RotationAngle = ang; 
	}
	return s;
}

function dos_punktir(s,punkt_dash,punkt_gap,punkt_size,punkt_trim,punkt_del,punkt_join,punkt_line){
	if(punkt_gap === undefined) punkt_gap = 0;
	if(punkt_size === undefined) punkt_size = true;
	if(punkt_trim === undefined) punkt_trim = false;
	if(punkt_del === undefined) punkt_del = true;
	if(punkt_join === undefined) punkt_join = true;
	if(punkt_line === undefined) punkt_line = false;	
	
	s.ConvertToCurves();
	ss = s.BreakApartEx();
	var srp = host.ActiveSelectionRange;
	srp.RemoveAll();

	var cnt_sps = ss.Count;
	for(var i=1;i<=cnt_sps;i++){
		ssp = ss(i);
		sp = ssp.Curve.Subpaths(1);
		sp_len = sp.length;
		if(punkt_trim) sp = sub_trim(sp,punkt_gap);
		
		if(punkt_dash>0){

			dashs = (punkt_size) ? (sp_len - punkt_dash) / (punkt_dash + punkt_gap) : punkt_dash;
			//alert(punkt_dash + ":" + punkt_gap + ":" + getRound(dashs,0) + ":" +dashs);
			sp.EqualDivide (getRound(dashs,0), punkt_gap);
			var todel = [];
			bynode = false;
			if(punkt_del){
				for(var n=1;n<=ssp.Curve.Nodes.Count;n++){
					if (!ssp.Curve.Nodes(n).IsEnding){
						todel.push(n);
						bynode = true;
					}
				}
				if (bynode){
					nr = ssp.Curve.Nodes.Range(1);
					nr.RemoveAll();
					for (var key in todel){
						nr.AddRange(ssp.Curve.Nodes.Range(todel[key]));
					}
					nr.Delete(); 
				}
				
			}
			
			if(punkt_line){
				for(var n=1;n<=ssp.Curve.Segments.Count;n++){
					seg = ssp.Curve.Segments(n);
					if(seg.Type > 0) seg.Type = 0;
				}
			}
		}
		srp.Add(ssp);
	}
	if (srp.Shapes.Count>1) s = srp.Combine();
	if(punkt_join) s.CustomCommand ("ConvertTo", "JoinCurves", punkt_gap + 0.1);	
	return s;
}

function calc_fast(){
	if(in_main) {
		if( host.ActiveShape != null ){
			shft = Shift();
			sel_cnt = host.ActiveSelection.Shapes.Count;
			if (sel_cnt>0){
				allen=0;
				alarea=0;
				OS = get_OS();
				
				for(var i=1;i<=OS.Shapes.Count;i++){
					s = OS.Shapes(i);
					if(s.DisplayCurve!==undefined && s.DisplayCurve!==null){
						allen += s.DisplayCurve.Length;
						alarea += one_shape_area(s,ch_calc_external.checked);
					}
				}
				allen *= wScale;
				alarea *= wScale;
				if(radio_calc_m.checked){
					allen /= 1000;
					alarea /= 1000000;
				}else if(radio_calc_cm.checked){
					allen /= 10;
					alarea /= 100;
				}
				calc_len_len.value = getRound(allen,4);
				calc_len_cost.value = getRound(allen * vall(val_calc_len_price.value,false),3);
				do_save(val_calc_len_price);

				calc_area_area.value = getRound(alarea,4);
				calc_area_cost.value = getRound(alarea * vall(val_calc_area_price.value,false),3);
				do_save(val_calc_area_price);
			}
		}
	}
}
/*
function all_shapes_area(ss, external){
    all_area = 0
    For Each s In ss
        If s.Shapes.Count > 0 Then
            all_area = all_shapes_area(s.Shapes, units, external)
        Else
            all_area = all_area + one_shape_area(s, units, external)
        End If
    Next s
    all_shapes_area = all_area
}*/


function one_shape_area(s,external){
	if(external === undefined) external = false;
	all_area = 0;
    if (external || s.Shapes.Count>0){
        all_area = s.SizeHeight * s.SizeWidth;
    }else{
        if (s.Shapes.Count==0){if (s.DisplayCurve){if(s.DisplayCurve.closed){
            s_info = get_subpath_info(s);
            all_area = 0;
			for (var cns=1;cns<=s.DisplayCurve.SubPaths.Count;cns++){
				sp  = s.DisplayCurve.SubPaths(cns);
                all_area = (s_info[cns][3] % 2 == 0 ) ? all_area + sp.Area : all_area - sp.Area;
			}
		}}}
	}
    return all_area;
}


function get_subpath_info(one_shape){
    var sup = [];
    
	if (one_shape.Shapes.Count==0){if(one_shape.DisplayCurve){
		sp_cnt = one_shape.DisplayCurve.SubPaths.Count;
		for (var cns=1;cns<=sp_cnt;cns++){
			sp  = one_shape.DisplayCurve.SubPaths(cns);
			sup[cns] = [cns, sp.Nodes.First.PositionX, sp.Nodes.First.PositionY,0,sp.BoundingBox.Left, sp.BoundingBox.Right, sp.BoundingBox.Top,sp.BoundingBox.Bottom];
		}
		maxc = 0;
		for (var i=1;i<=sp_cnt;i++){
			for (var cns=1;cns<=sp_cnt;cns++){
				if(i!=cns){
					sp  = one_shape.DisplayCurve.SubPaths(cns);
					if (sp.BoundingBox.Left < sup[i][5]){
						if (sp.BoundingBox.Right > sup[i][4]){
							if (sp.BoundingBox.Top > sup[i][7]){
								if (sp.BoundingBox.Bottom < sup[i][6]){
									res = sp.IsOnSubPath(sup[i][1],sup[i][2]);
									if (res == 2) sup[i][3]++
								}
							}
						}
					}
				}
			}
		}
	}}
    return sup;
}

function GetShapesInfo(){
	if(host.Activeshape){
		numSelected.value = get_OS().Shapes.Count;
		objectName = host.Activeshape.Evaluate("@type"); // use CQL to get the object type name
		selectedObject.value = objectName;
		wi = host.ActiveShape.SizeWidth;
		hi = host.ActiveShape.SizeHeight;
		info_wi.value = wi*wScale;
		info_hi.value = hi*wScale;
		dd = info_del.value;
		val = vall(dd.substring(1),false);
		switch (dd.substring(0,1)){
			case "/": wid = wi/val; hid=hi/val; break;
			case "*": wid = wi*val; hid=hi*val; break;
			case "-": wid = wi-val; hid=hi-val; break;
			default: wid = wi+val; hid=hi+val; break;
		}
		info_wid.value = vall(wid*wScale,false,4);
		info_hid.value = vall(hid*wScale,false,4);
	}
}

function do_move(tit,dir){
	if (tit=="reset"){
		if (confirm(lang['cats_reset_confirm'])){
			sWrite('cats',"1/2");
			location.reload();
		}
	}else{
		domove = true;
		var elems = document.getElementsByTagName('p');
		prv = "";
		nxt = "";
		fnd = false;
		ids = tit.substring(6);
		for (var i = 0; i < elems.length; i++){
			var el = elems[i];
			if(el.id.substring(0,10)=="title_cat_"){
				if (fnd) {nxt = el.id; break;}
				if(el.id==tit) fnd = true;
				if (!fnd) prv = el.id;
			}
		}
		
		el_prv = false;
		if(dir=="up" && prv.length>2){
			el_nxt1 = document.getElementById(tit);
			el_nxt2 = document.getElementById(ids);
			el_prv = document.getElementById(prv);
		}
		if(dir=="dn" && nxt.length>2){
			el_nxt1 = document.getElementById(nxt);
			nids = nxt.substring(6);
			el_nxt2 = document.getElementById(nids);
			el_prv = document.getElementById(tit);
		}

		if(el_prv){
			document.body.insertBefore(el_nxt1,el_prv);		
			document.body.insertBefore(el_nxt2,el_prv);		
		}
		
		var cats = [];
		for (var i = 0; i < elems.length; i++){
			var el = elems[i];
			if(el.id.substring(0,10)=="title_cat_"){
				cats.push(el.id);
			}
		}
		all_cats = cats.join("/");
		sWrite('cats',all_cats);
	}
}

function do_events(bid){
	//warn("");
}

function do_save(el,min,max){
	if(min === undefined) min = false;
	if(max === undefined) max = false;
	key = el.id;
	var val = null;
	if (key.substring(0,4)=="cat_"){
		val = (el.style.display == "block") ? true : false;
	}else if(key.substring(0,3)=="ch_"){
		val = el.checked;
	}else{
		val = el.value;
	}		

	if(key.substring(0,6)=="radio_"){
		var elems = document.getElementsByName(el.name);
		for (var i = 0; i < elems.length; i++){
			val = (elems[i].checked) ? "true" : "false";
			sWrite(elems[i].id,val);
		}		
	}else if(val!=null){
		if (min && max){
			if (val<min) val=min;
			if (val>max) val=max;		
		}
		if(val === true) val = "true";
		if(val === false) val = "false";
		sWrite(key,val);
	}
	
	if(key=="lang" || key=="bgcolor" || key=="ch_set_titles_move" || key=="ch_set_titles" || key=="val_set_conturs"){
		location.reload();
	}		
}
function do_read(){
	var elems = document.getElementsByTagName('*');
	for (var i = 0; i < elems.length; i++){
		el = elems[i];
		key = el.id;
		val = sRead(el.id);
		if (val!=undefined){
			if(val == "true") val = true;
			if(val == "false") val = false;
			if (key.substring(0,4)=="cat_"){
				ShowCat(key,val);
			}else if(key.substring(0,3)=="ch_" || key.substring(0,6)=="radio_"){
				el.checked=val;
			}else if(key.substring(0,4)=="val_"){
				el.value=val;
			}		
		}
	}		
}

function do_begin(undoname,undogroup,optimize,units,sett){
	if(host.ActiveDocument!=null){
		if(undoname === undefined) undoname = "do somth";
		if(undogroup === undefined) undogroup = true;
		if(optimize === undefined) optimize = false;
		if(units === undefined) units = 3;
		if(sett === undefined) sett = "before";
		host.ActiveDocument.SaveSettings(sett);
		host.ActiveDocument.Unit = units;
		if(undogroup) host.ActiveDocument.BeginCommandGroup(undoname);
		host.Application.Optimization = optimize;
		host.EventsEnabled = !optimize;
	}
}

function do_end(undogroup,sett){
	if(host.ActiveDocument!=null){
		if(undogroup === undefined) undogroup = true;
		if(sett === undefined) sett = "before";
		do_cure(undogroup);
		host.ActiveDocument.RestoreSettings(sett);
		host.ActiveWindow.Activate();	
	}
}

function do_cure(undogroup){
	if(host.ActiveDocument!=null){
		if(undogroup === undefined) undogroup = true;
		host.EventsEnabled = true;
		host.Application.Optimization = false;
		host.Application.Refresh();
		host.DoEvents;
		if(undogroup) host.ActiveDocument.EndCommandGroup();
		
/*
		os = get_OS();
		if (os.Shapes.Count==2){
			s1 = os.Shapes(1);
			s2 = os.Shapes(2);
			rets = circles2(s1.centerX,s1.centerY,s1.SizeWidth/2,s2.centerX,s2.centerY,s2.SizeWidth/2);
			alert(rets);
			if(rets.length>0) el1 = host.ActiveLayer.CreateEllipse2(rets[0], rets[1],10);
			if(rets.length>2) el1 = host.ActiveLayer.CreateEllipse2(rets[2], rets[3],20);
			
		}
*/		
	}
}
	
function get_OS(bycolor, ingroup){
	if(defdoc()){
		if(bycolor === undefined) bycolor = true;
		if(ingroup === undefined) {
			shft = Shift();
			ingroup = (shft==1 || shft==3 || shft==5 || shft==7) ? true : false;
		}
		if(bycolor){
			os = select_colors();
		}else{
			os = host.ActiveSelectionRange;
			if(radio_sett_doc.checked){
				os.RemoveAll();
				for (i=1;i<=host.ActiveDocument.Pages.Count;i++){
					os.AddRange(host.ActiveDocument.Pages(i).Shapes.All());
				}
			}else if(os.Shapes.Count==0) {
				os = host.ActivePage.Shapes.All();
			}
		}
		//if (ingroup) os = os.Shapes.FindShapes("", 0, ingroup, "@Name!='dsf'");
		if (ingroup) os = getInGroup(os);
		return os;	
	}else{
		return getEOS();
	}
}

function getInGroup(OSS){
	var sr = host.ActiveSelectionRange;
	sr.RemoveAll();
	for (var i=1;i<=OSS.Shapes.Count;i++){
		var s = OSS.Shapes(i);
		if (s.Shapes.Count==0){
			sr.Add(s);
		}else{
			sr.AddRange(getInGroup(s.Shapes.All()));
		}
	}	
	return sr;
}

function FindSegXY(glx, gly, sel){
	fnd = false;
	for(var i=1;i<=sel.Shapes.Count;i++){
		sa = sel.Shapes(i);
        if (sa.DisplayCurve){
            sfnd = sa.DisplayCurve.FindSegmentAtPoint(glx, gly, 0, 50000);
            if(sfnd) fnd = sfnd;
        }else{
            fnd = FindSegXY(glx, gly, sa);
        }
    }
    if(!fnd) fnd = sel.FirstShape.DisplayCurve.Segments(1);
    return fnd;
}


function max_ang(s, check_ang){
	if(check_ang === undefined) check_ang = true;
	ang = 0;
	if (s){
		if (check_ang && s.RotationAngle!=0) {
			ang  = s.RotationAngle;
		}
		if (ang==0){
			max = 0;
			imax = 0;
			for(var k=1;k<=s.DisplayCurve.Segments.Count;k++){
				len = s.DisplayCurve.Segments(k).Length;
				if (len>max){
					max = len;
					imax = k;
				}
			}
			ang = s.DisplayCurve.Segments(imax).EndingControlPointAngle;	
		}
	}
	return ang;
}
function max_size(s){
	max = s.SizeWidth;
	if (s.SizeHeight>max) max = s.SizeHeight;
	return max;
}

function lastSize(lst, perimetr){
	if(perimetr === undefined) perimetr = false
	siz = 0;
	if(isSimpleShape(lst)){
		clsd = true;
		if(lst.DisplayCurve) if(!lst.DisplayCurve.closed) clsd = false;
		if(clsd){
			if (ch_master_sel_h.checked && !ch_master_sel_w.checked){
				siz = lst.SizeHeight;
			}else if (!ch_master_sel_h.checked && ch_master_sel_w.checked){
				siz = lst.SizeWidth;
			}else{
				siz = (perimetr) ? lst.DisplayCurve.Length :  max_size(lst);
			}
		}else{
			siz = lst.DisplayCurve.length;
		}
	}
	return siz;
}


function maxSPArea(s){
	area = 0;
	if (s){
		max = 0;
		for(var k=1;k<=s.DisplayCurve.SubPaths.Count;k++){
			sp = s.DisplayCurve.SubPaths(k);
			if(sp.closed){
				are = sp.Area;
				if (are>max) max = are;
			}
		}
		area = max;
	}
	return area;
}


function sub_trim(spp, gap){
	shft = Shift();
	if(spp.closed && shft==2) spp.Nodes.First.BreakApart();
	if(!spp.closed){
		spp.AddNodeAt(gap, 0);
		spp.AddNodeAt(spp.length - gap, 0);
		spp.Nodes.First.Delete();
		spp.Nodes.Last.Delete();
	}	
	return spp;
}

function getRef(setDoc){
	if(setDoc === undefined) setDoc = true;
	s = host.ActiveLayer.CreateEllipse2(0,0,100);
	sx = s.CenterX;
	sy = s.CenterY;
	host.FrameWork.Automation.InvokeItem("e6644135-9dab-4935-8ab9-fc85527810ca");
    host.FrameWork.Automation.InvokeItem("6ae897fd-2eab-4dad-b172-f4fb768c273e");
	ex = s.CenterX;
	ey = s.CenterY;
	//s.Delete();
	if(ey > sy){
		refpt = 2;
		if(ex<sx) refpt = 3;
		if(ex>sx) refpt = 1;
	}else if(ey < sy){
		refpt = 6;
		if(ex<sx) refpt = 5;
		if(ex>sx) refpt = 7;
	}else{
		refpt = 9;
		if(ex<sx) refpt = 4;
		if(ex>sx) refpt = 8;
	}

	if(setDoc) host.ActiveDocument.ReferencePoint = refpt;
	return refpt;
}

function hextorgb(hex) {
	if(hex === undefined) hex = '000';
	var arr = [0,0,0];
	if (hex.length==3)
		str = "" + hex.substring(0,1) + hex.substring(0,1) + hex.substring(1,2) + hex.substring(1,2) + hex.substring(2,3) + hex.substring(2,3);
	else if (hex.length==6)
		str = "" + hex;
	else 
		str = false;
	if (str){
		arr = [parseInt(str.substring(0,2),16),parseInt(str.substring(2,4),16),parseInt(str.substring(4,6),16)];
	}
	return arr;
}

function getRadio(name){
	check = "";
	var elems = document.getElementsByName(name);
	for (var i = 0; i < elems.length; i++){
		var el = elems[i];
		if(el.checked) break;
	}
	return el;
}

function replaceAll(str, find, replace) {
  return str.replace(new RegExp(find, 'g'), replace);
}

function arrwarn(arr){
	txt = "";
	for(i=0;i<=arr.length;i++){
		if(arr[i][0]!=null){
			//alert("i"+i);
			for(j=0;j<=arr[i].length;j++){
				if(arr[i][j]!=null){
					//alert("j"+j);
					txt += "arr["+i+",]["+j+"]=" + arr[i][j] + "<br>";
				}
			}
		}
	}
	return txt;
}

function circles2(x1, y1, r1, x2, y2, r2,xn,yn) {
  // Calculate the dist between the centers of the two circles
  dist = distXY(x1, y1, x2, y2);

  // Check if the two circles intersect
  if (dist <= r1 + r2 && dist >= Math.abs(r1 - r2)) {
    // Calculate the intersection points
    a = (r1*r1 - r2*r2 + dist*dist)/ (2 * dist);
    h = Math.sqrt(r1*r1 - a*a);
    x3 = x1 + (a * (x2 - x1)) / dist;
    y3 = y1 + (a * (y2 - y1)) / dist;

    if (dist == r1 + r2) {
      return [x3,y3];
    }

    x4 = x3 + (h * (y2 - y1)) / dist;
    y4 = y3 - (h * (x2 - x1)) / dist;
    x5 = x3 - (h * (y2 - y1)) / dist;
    y5 = y3 + (h * (x2 - x1)) / dist;

	if(xn != undefined && yn != undefined){
		if(Math.sqrt((x4 - n1)^2 + (y4 - yn)^2) > Math.sqrt((x5 - n1)^2 + (y5 - yn)^2)){
			return [x5,y5,x4,y4];
		}
	}
	
	return [x4,y4,x5,y5];
  }

  // If the two circles do not intersect, return an empty array
  return [];
}

function Shift(){
	ret = 0;
	if(window.event.shiftKey) ret++;
	if(window.event.ctrlKey) ret+=2;
	if(window.event.altKey) ret+=4;
	return ret;
}
function distXY(x1,y1,x2,y2){return Math.sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));}

function isShift (shft){return (shft==1 || shft==3 || shft==5 || shft==7) ? true : false;}
function isCtrl (shft){return (shft==2 || shft==3 || shft==6 || shft==7) ? true : false;}
function isAlt (shft){return (shft>3)  ? true : false;}
function isLast(OS, global_master){
	if(global_master === undefined) global_master = false;
	 ret = (Shift()==7 && OS.Shapes.Count>0);
	 if (global_master) ret = (ret || (master && ch_master_sample.checked)) 
	 return ret;
}

function isSimpleShape(s,arrno){
	if(arrno === undefined) arrno = [10,11,12,13,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30];
//	return false;
	return (s.type<10 || s.type==14) ? true : false;
}

function warn(text){
	warning.style.display = "block";
	warning.innerHTML = text;
}	

function getRandom(max, min,dig) {
	if(max === undefined) max = 10;
	if(min === undefined) min = 1;
	if(dig === undefined) dig = 4;
    min = Math.ceil(min);
    max = Math.floor(max);
    return getRound(Math.random() * (max - min + 1),dig) + min;
}
function getRound(val,dig){
	if(dig === undefined) dig = 4;
	ret = vall(val,false,-1);
	if(dig>0){
		ret = ret.toString();
		ind = ret.indexOf(".");
		if (ind<1) ind = ret.length;
		ret = ret.substring(0,ind+dig+1)
		ret.parseFloat;
		ret*=1;
	}
    return ret;
}

function vall(srcc, scale, round){
	var src = srcc;
	if (src!=null){
		if(round === undefined) round = -1;
		if(scale === undefined) scale = true;
		scal = (scale) ? 1 : wScale;
		src = src.toString().replace(",",".");
		src.parseFloat;
		src = src / scal;
		if(round>-1) src = getRound(src,round);
		return src;
	}else{
		return false;
	}
}

function defdoc(){
	wScale = 1;
	ret = false;
	if(host.ActiveDocument){
		host.ActiveDocument.Unit=3;
		host.ActiveDocument.ReferencePoint = 9;
		wScale = host.ActiveDocument.WorldScale;
		ret = true;
	}	
	return ret;
}

function chr( ascii ) {return String.fromCharCode(ascii);}


// VBA functions

function ReadFile(name){return host.GMSManager.RunMacro("wpanel", "Macros.ReadFile", name).split(chr(10));}
function ReadFolder(name){return host.GMSManager.RunMacro("wpanel", "Macros.ReadFolder", name).split(chr(10));}
function sRead(name){return host.GMSManager.RunMacro("wpanel", "Macros.regR", name);}
function sWrite(name,val){return host.GMSManager.RunMacro("wpanel", "Macros.regW", name, val);}
function sStatSend(ver){return host.GMSManager.RunMacro("wpanel", "Macros.stat_send",ver);}
function getClick(){return host.GMSManager.RunMacro("wpanel", "Macros.getClick").split(":");}
function getSegOffbyXY(seg,xx,yy){return host.GMSManager.RunMacro("wpanel", "Macros.getSegOffbyXY", seg, xx, yy);}
function MakeSize(dir, shft){return host.GMSManager.RunMacro("wpanel", "Macros.make_sizes_sep", dir, shft);}


function getEOS(){
	if(host.ActiveDocument!=null){
		var esr = host.ActiveSelectionRange;
		esr.RemoveAll();
		return esr;
	}else{
		return host.GMSManager.RunMacro("wpanel", "Macros.getOS");
	}
}