lang['text_width'] = "width";
lang['text_height'] = "height";
lang['text_th'] = "thickness";
lang['text_rotate'] = "Angle";
lang['text_lang'] = "language: ";
lang['text_color'] = "color: ";
lang['text_more50'] = "Are you sure you want to process that many objects at once?";
lang['text_type'] = "type";
lang['text_short_help'] = "<h5>Briefly about how to work with this panel</h5><p>Most of the functions (buttons) are related to the color scanner, and if some colors are selected there, then almost any action will be without having to press the 'select' button too much.</p><p>Clicking almost any button while holding down the Shift key allows you to interact with objects within groups without ungrouping. Other additional functions are described in the tooltips for the buttons.</p><p> Clicking on the header collapses and expands it, if you click with Alt pressed, then all sections except the selected one will be hidden.</p><p>Well, in general, there is a lot of useful information in the tips, read them carefully, look in the settings to configure the panel for yourself.< /p>";


lang['title_cat_colors'] = "Quick Pick";
hint['title_cat_colors'] = "A set of handy buttons for quickly selecting objects by color, type, or other features";
btns['button_scan_colors'] = "Search";
hint['button_scan_colors'] = "Search by color /+ Shift Including subgroups.";
btns['button_select_colors'] = "Select";
hint['button_select_colors'] = "Select objects by color /+ Ctrl except for selected color / + +Shift including subgroups.";
lang['ch_selcol_group'] = "groups.";
hint['ch_selcol_group'] = 'group selected objects by color';
lang['ch_selcol_move'] = "move.";
hint['ch_selcol_move'] = "move objects by color";
btns['button_sel_toup'] = "src:img/level_up.png";
hint['button_sel_toup'] = "Move to the top level of the layer.";
btns['button_sel_todown'] = "src:img/level_down.png";
hint['button_sel_todown'] = "Move to the bottom of the layer.";
btns['button_del_colors'] = "src:img/trash.gif";
hint['button_del_colors'] = 'Delete Selected Items';
lang['title_cat_contur'] = "Contour and Fillet";
hint['title_cat_contur'] = 'Multiple Contour and Fillet';
btns['cont_out_'] = "out";
hint['cont_out_'] = "Outline for single objects /Shift +1 /Ctrl +0.1 / Ctrl+Shift +0.5 /Alt+Shift invert *delete*";
btns['cont_in_'] = "In";
hint['cont_in_'] = "Inner outline for single objects /Shift -1 /Ctrl -0.1 / Ctrl+Shift -0.5 /Alt+Shift invert *delete*";
btns['cont_round_'] = 'Round';
hint['cont_round_'] = 'Round selected entities or nodes';
lang['ch_cont_sep'] = "split";
hint['ch_cont_sep'] = "split contour after creation";
lang['ch_cont_del'] = "delete";
hint['ch_cont_del'] = "delete original object after creation (doesn't work without splitting)";
lang['ch_cont_round'] = "round";
hint['ch_cont_round'] = "Round the contour of the creation box";
lang['ch_cont_reduce'] = "smooth";
hint['ch_cont_reduce'] = 'smooth contour after creation';
lang['ch_cont_smart'] = "y";
hint['ch_cont_smart'] = "smart contour is given to closed objects on both sides";
lang['sel_by_type_qty'] = "Qty:";
hint['sel_by_type_qty'] = "number of objects in selection";
lang['sel_by_type_type'] = "Type:";
hint['sel_by_type_type'] = "The type of the last selected object";
lang['sel_by_type_length'] = "Length:";
hint['sel_by_type_length'] = "Total length of all perimeters (including in groups)";
hint['ch_check_length'] = "Check object lengths greater than 300.";
btns['sel_by_type_rect'] = "Rectangle";
hint['sel_by_type_rect'] = "Select standard rectangles /+Ctrl select all except rectangle / +Shift including in subgroups";
btns['sel_by_type_elipse'] = "Circle";
hint['sel_by_type_elipse'] = "Select standard ellipses /+Ctrl select all except ellipses / +Shift including in subgroups";
btns['sel_by_type_curve'] = "Curve";
hint['sel_by_type_curve'] = "Select custom curves /+Ctrl select all except curves / +Shift including in subgroups";
btns['sel_by_type_poly'] = "Polygon";
hint['sel_by_type_poly'] = "Select standard polygons /+Ctrl select all except polygons / +Shift including in subgroups";
btns['sel_by_type_text'] = "Text";
hint['sel_by_type_text'] = "Select all text objects / +Ctrl select all except text/ +Shift including in subgroups";
btns['sel_by_type_groups'] = "Groups";
hint['sel_by_type_groups'] = "Select grouped objects /+Ctrl select all except groups";
btns['sel_by_type_same'] = 'By Selected';
hint['sel_by_type_same'] = "Select objects by last object /+Ctrl select all except this type / +Shift including in subgroups";
btns['sel_by_type_clopen'] = "Closed";
hint['sel_by_type_clon'] = 'Select closed objects /+Ctrl NOT closed / +Shift including in subgroups';
btns['sel_by_type_fillno'] = "Fill";
hint['sel_by_type_fillno'] = "Select objects with normal fill /+Ctrl WITHOUT fill / +Alt fountain or other fill / +Shift including in subgroups";
btns['sel_by_type_outlno'] = "Outline";
hint['sel_by_type_outlno'] = "Select entities with outline /+Ctrl WITHOUT outline / +Shift including in subgroups";
btns['sel_by_type_images'] = "Raster";
hint['sel_by_type_images'] = "Select raster objects /+Ctrl all but raster / +Shift including in subgroups";
btns['sel_by_type_effectno'] = "Effects";
hint['sel_by_type_effectno'] = "Select objects with applied effect /+Ctrl all but effects/ +Shift including in subgroups";
btns['sel_by_type_locks'] = "Locked.";
hint['sel_by_type_locks'] = "Select locked objects /+ Ctrl unlock all";
btns['sel_by_type_pwrc'] = "PowerClip ";
hint['sel_by_type_pwrc'] = "Select powerclip objects /+Ctrl all except / +Shift including in subgroups";


lang['title_cat_autogroup'] = 'Group, Merge, Cut';
hint['title_cat_autogroup'] = 'Automatic actions on touching (or gapped) objects';
lang['txtgroupgap'] = "Gap:";
hint['txtgroupgap'] = "Gap for automatic grouping, merging and cutting (doesn't work for shape)";
btns['grp_byframe'] = "Border";
hint['grp_byframe'] = "Auto-group by object's outer (square) frame";
btns['grp_byform'] = "Form";
hint['grp_byform'] = "Auto-group by object shape with strict chaining of objects to each other";
btns['grp_byrow'] = "Row";
hint['grp_byrow'] = "Auto-group by row (coincidence of centers)";
btns['grp_bycolumn'] = "Column";
hint['grp_bycolumn'] = "Auto-Group By Columns (By Coincident Centers)";
btns['grp_addto'] = 'Add to Group';
hint['grp_addto'] = 'Add object to group';
btns['grp_weld'] = 'Drain';
hint['grp_weld'] = "Merge all touching objects (by gap) / +Alt - combine objects";
btns['grp_autocut'] = 'Cut';
hint['grp_autocut'] = 'Cut objects from the largest (by area) cut all others';
btns['all_split'] = "split everything";
hint['all_split'] = "Split all objects, effects, get everything out of powerclips.";

lang['title_cat_master'] = "Replace, swap, substitute";
hint['title_cat_master'] = "Highlight, Replace, Substitute, Pattern Fill";
btns['master_set'] = 'Set Master';
hint['master_set'] = "Set the selected object as a reference for further operations./Ctrl select the master object";
btns['change_pos'] = "Change";
hint['change_pos'] = "Swap two selected objects.";
lang['ch_master_del'] = "Delete";
hint['ch_master_del'] = 'Delete Swapped Object';
lang['ch_master_rotate'] = "Rotate";
hint['ch_master_rotate'] = "Rotate the spoofed object if there is an angle state, then by the state, if the angle is zero, then by the longest side.";
btns['master_replace'] = "Replace";
hint['master_replace'] = 'Replace the master in the place of the selected object';
lang['ch_master_size'] = "Size";
hint['ch_master_size'] = "Fit the master size to the size of the object being replaced.";
lang['ch_master_byends'] = "Byends";
hint['ch_master_byends'] = "Place a master at the ends of all segments of the object.";
btns['master_select'] = "Select";
hint['master_select'] = "Select objects according to certain properties (length, width, etc.)/ + Ctrl less than or equal to or greater than or equal to";
lang['ch_master_sel_h'] = lang['text_width'];
lang['ch_master_sel_w'] = lang['text_height'];
lang['radio_master_sel_l'] = "<";
lang['radio_master_sel_m'] = ">";
lang['radio_master_sel_e'] = "=";
btns['master_fill'] = 'Fill';
hint['master_fill'] = "Fill shape with master / +Shift increased tolerance (7% area) to hit the shape / +Alt alternate placement (dense for circles)";
lang['ch_master_fill_bycenter'] = 'by center';
lang['master_fill_kraj'] = "from the edge";
lang['master_fill_gap'] = "between";
lang['radio_master_fill_full'] = "full";
lang['radio_master_fill_part'] = "partial";
lang['radio_master_fill_out'] = "out";
lang['radio_master_fill_all'] = "all";

lang['title_cat_sizes'] = "Size, perimeter, scale";
lang['ch_sizes_aspect'] = "proportions";
lang['ch_sizes_rotate'] = "rotate";
btns['set_sizes'] = "Size";
hint['set_sizes'] = 'Change the size of each individual object';
lang['perimeter_title'] = "Perimeter";
hint['perimetr_get_size'] = 'Get Curve Length';
btns['perimetr_set_size'] = 'Fit';
btns['mashtab_set_size'] = "Scale";
lang['mashtab_title'] = 'Fit scale to first object';
lang['ch_rotate_rel'] = "relates.";

lang['make_sizes_txt'] = 'Make dimensions';
btns['btn_make_sizes'] = 'Make Sizes';
hint['btn_make_sizes'] = "Size /+Ctl on the other side /+Alt make the whole selection";
lang['ch_sizes_hor'] = "horizontal";
lang['ch_sizes_ver'] = "vertical";
lang['ch_sizes_betw'] = "between";

lang['title_cat_raspred'] = 'Spread and Rotate';
lang['raspred_raspred'] = "Distribution";
btns['raspred_qty'] = "by quantity";
hint['raspred_qty'] = "Evenly distribute the object (duplication) along the selected path.";
btns['raspred_dist'] = "by distance";
hint['raspred_dist'] = "Distribute objects by sparing distance /+Ctrl when distributing existing objects, keep the distances between the original objects";
btns['raspred_nodes'] = "by nodes";
hint['raspred_nodes'] = "Distribute objects along the nodes of the selected curve. /+Ctrl only on straight segments (useful when placing notches for bending Plexiglas)";
btns['raspred_round'] = 'round';
hint['raspred_round'] = "Spread objects evenly around last selected clockwise/+Ctrl start from top";
btns['raspred_shapes'] = 'Spread over objects';
hint['raspred_shapes'] = "Spread the first half of objects into the second. /+Shift reverse order. /+Ctrl swap places /+Alt Rename objects (half must be text)";
lang['ch_raspred_rotate'] = "rotate";
lang['ch_raspred_center'] = 'centered';

hint['rotate_set_angle'] = "Rotate each object by the given angle /+Alt rotate clockwise";
lang['txt_rotate_ang'] = "Rotate counterclockwise by an angle ";
lang['txt_rotate_0'] = "° /+Alt rotate clockwise /+Ctrl reset the rotation center to the center of the shape";
hint['rotate_set_0'] = lang['txt_rotate_ang'] + '0' + lang['txt_rotate_0'];
hint['rotate_set_45'] = lang['txt_rotate_ang'] + '45' + lang['txt_rotate_0'];
hint['rotate_set_90'] = lang['txt_rotate_ang'] + '90' + lang['txt_rotate_0'];
hint['rotate_set_180'] = lang['txt_rotate_ang'] + '180' + lang['txt_rotate_0'];
hint['rotate_set_270'] = lang['txt_rotate_ang'] + '270' + lang['txt_rotate_0'];
btns['rotate_set_long'] = "long";
hint['rotate_set_long'] = 'Rotate to zero by an angle along the longest segment';
btns['rotate_set_ang'] = "rotate";
hint['rotate_set_ang'] = "Rotate to zero by an angle along the specified segment /+Ctrl rotate by an angle";


lang['title_cat_punktir'] = 'Dotted, chiselled, webs';
hint['title_cat_punktir'] = "Dotted, torn, or undercut webs.";
lang['punkt_dash'] = "dash";
lang['punkt_gap'] = "gap";
lang['razryv'] = "jumpers";
lang['radio_punktir_size'] = "rr";
lang['radio_punktir_mm'] = "number";
btns['make_punktir'] = "Dotted";
hint['make_punktir'] = "Create a dotted line on all object lines /+Ctrl truncate also closed shapes";
btns['make_trim'] = "Trim";
hint['make_trim'] = "Trim lines from ends to break size";
lang['ch_punkt_del'] = "delete";
hint['ch_punkt_del'] = "Remove the original points on the line and leave only the new ones created at the breaks";
lang['ch_punkt_join'] = "join";
hint['ch_punkt_join'] = 'Join broken dots';
lang['ch_punkt_line'] = "polyline";
hint['ch_punkt_line'] = 'Convert curved segments to a straight line';
lang['ch_punkt_trim'] = "trim";
hint['ch_punkt_trim'] = 'Trim start and end of dotted line /+Ctrl trim also closed shapes';

lang['freza'] = "to cut";
lang['freza_title'] = "How thick is the plywood?";
btns['freza_inside'] = "Inside";
hint['freza_inside'] = "Freza cutout spacing /+Ctrl center /+Alt hidden spacing method";
btns['freza_outside'] = "Outside";
hint['freza_outside'] = hint['freza_inside'];
lang['ch_freza_corners'] = "round corners";
hint['ch_freza_corners'] = 'Round outside or inside corners';
btns['btn_narrow'] = "bottlenecks";
hint['btn_narrow'] = 'Mark bottlenecks between lines';

btns['make_gap'] = "Gap";
hint['make_gap'] = "Set a break point on the line of an object /+Shift at the place of the selected objects / +Ctrl - according to the shape of the selected objects /+Alt (with Shift or Ctrl) do not delete the selected objects";
lang['ch_razryv_nedorez'] = "undercut";
lang['ch_razryv_circle'] = "circles";
btns['razryv_color'] = "set color";
hint['razryv_color'] = "Set the line color for the break (the color of the circle will be inverted)";
btns['razryv_del'] = "delete circles";
hint['razryv_del'] = 'Delete circles that mark undercuts';

lang['title_cat_info'] = "Miscellaneous Information";
lang['title_cat_fefco'] = "FEFCO Boxes";

lang['title_cat_settings'] = 'Panel Settings';
lang['radio_sett_selected'] = 'Selected';
hint['radio_sett_selected'] = "Work with objects in the selected area (if you remove the selection, work on the entire sheet)";
lang['radio_sett_doc'] = "in document";
hint['radio_sett_doc'] = "Work with objects throughout the document";
lang['ch_set_titles'] = 'Show titles';
lang['ch_set_titles_move'] = "move";
btns['cats_reset'] = "reset";
lang['cats_reset_confirm'] = "You've been poking arrows for so long.\n\nAre you sure you want to reset the toolbar's layout to default?";
lang['val_set_conturs'] = "Number of contours: ";
hint['val_set_conturs'] = "The number of input fields for the contour section is optimally 5-8 (maximum 10)";
btns['doc_cure'] = 'Cure korel';
hint['doc_cure'] = "Try to fix corel after macro/tool ​​failed";


lang['warn_no_selected_in_group'] = "Not all objects are selected because some objects are in groups";
var gl_units = ["dmr","inch","ft","mm","cm","px","miles","m","km","dd","Ag","yrd ","pc","cc","pt","UQ","UH"];
